//---------------------------------------------------------------------------

#ifndef childH
#define childH
//---------------------------------------------------------------------------

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <Buttons.hpp>
#include <Grids.hpp>
#include <Mask.hpp>

//---------------------------------------------------------------------------

enum {STOP, RUNNING}; // run states

typedef struct ITER
{
	struct ITER* next;
        int prev_state;
	char* input;
	int move; // -1, 0, 1, anything else for stop
}
ITER;

class TChild : public TForm
{
	__published:	// IDE-managed Components
		TPopupMenu *ChildPopUpMenu;



	TGroupBox *GroupBox1;
	TLabel *Label1;
	TLabel *Label2;
	TLabel *Label3;
	TSpeedButton *LeftSpeedButton;
	TSpeedButton *StopSpeedButton;
	TSpeedButton *RightSpeedButton;
	TLabel *Label5;
	TLabel *Label4;
	TComboBox *StateComboBox;
	TComboBox *NewStateComboBox;
	TListView *StateListView;
	TButton *NewButton;
	TButton *DelButton;
	TMaskEdit *InputEdit;
	TMaskEdit *OutputEdit;
	TButton *CopyButton;
	TStringGrid *DataGrid;
	TAnimate *Animate;
	TStringGrid *StringGrid1;
	TStringGrid *StringGrid2;
	TSpeedButton *SpeedButton1;
	TSpeedButton *SpeedButton2;
	TBitBtn *ResetButton;
	TBitBtn *RunButton;
	TLabel *Label6;
	TPopupMenu *BandPopup;
	TMenuItem *ClearBand;
	TPopupMenu *ListPopup;
	TMenuItem *ClearList;

		void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
		void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall StateListViewSelectItem(TObject *Sender, TListItem *Item,
          bool Selected);
	void __fastcall StateChange(TObject *Sender);
	void __fastcall NewButtonClick(TObject *Sender);
	void __fastcall CopyButtonClick(TObject *Sender);
	void __fastcall DelButtonClick(TObject *Sender);
	void __fastcall RunButtonClick(TObject *Sender);
	void __fastcall StateComboBoxKeyPress(TObject *Sender, char &Key);
	void __fastcall StateComboBoxExit(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall ResetButtonClick(TObject *Sender);
	void __fastcall SpeedButton1Click(TObject *Sender);
	void __fastcall SpeedButton2Click(TObject *Sender);
	void __fastcall GridKeyPress(TObject *Sender, char &Key);
	void __fastcall GridGetEditMask(TObject *Sender, int ACol, int ARow,
          AnsiString &Value);
	void __fastcall ClearBandClick(TObject *Sender);
	void __fastcall GridEnter(TObject *Sender);
	void __fastcall ClearListClick(TObject *Sender);

	private:
		TListItem* current_item; // currently selected state in StateListView

		String input;	// current input from bands

		void __fastcall do_state();
	public:
		__fastcall TChild(TComponent* Owner):
		TForm(Owner),
		named(false),
		modified(false),
		grid_pos(0),
		current_item(NULL),
		iter_list(NULL){ };


		bool named; // has the file been given a name yet? If not, Save = Save As
		bool modified; // has anything changed that needs to be saved?

		// store changes made 1 on run/single step iteration
		int grid_pos;
		int state;

		struct ITER* iter_list;


};
//---------------------------------------------------------------------------

extern PACKAGE TChild *Child;
//---------------------------------------------------------------------------

#endif
