//---------------------------------------------------------------------------

#ifndef mainH
#define mainH

//---------------------------------------------------------------------------

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include "child.h"
#include <ActnList.hpp>
#include <AppEvnts.hpp>
#include <ImgList.hpp>
#include <StdActns.hpp>
//---------------------------------------------------------------------------

class TMain : public TForm
{
	__published:	// IDE-managed Components

		TMainMenu *MainMenu;
		    TMenuItem *FileMenu;
			TMenuItem *FileNew;
			TMenuItem *FileOpen;
			TMenuItem *FileClose;
			TMenuItem *N1;
			TMenuItem *FileSave;
			TMenuItem *FileSaveAs;
			TMenuItem *N2;
			TMenuItem *FileExit;
		    TMenuItem *EditMenu;
			TMenuItem *EditUndo;
			TMenuItem *N3;
			TMenuItem *EditCut;
			TMenuItem *EditCopy;
			TMenuItem *EditPaste;
		    TMenuItem *ViewMenu;
			TMenuItem *ViewToolbar;
			TMenuItem *ViewStatusBar;
		    TMenuItem *WindowMenu;
			TMenuItem *WindowCascade;
			TMenuItem *WindowTile;
			TMenuItem *WindowArrangeIcons;
		    TMenuItem *HelpMenu;
			TMenuItem *N4;
			TMenuItem *HelpTopics1;
			TMenuItem *HelpAbout;

		TPopupMenu *ToolBarPopupMenu;
		    TMenuItem *PopUpToolbar;
		    TMenuItem *PopUpStatusBar;
		TPopupMenu *MainPopupMenu;
			TMenuItem *PopUpNew;
			TMenuItem *PopUpOpen;
			TMenuItem *N5;
			TMenuItem *PopUpExit;

		TOpenDialog *OpenDialog;
		TSaveDialog *SaveDialog;
		TStatusBar *StatusBar;

		TImageList *ImageList;
		TActionList *ActionList;
		TApplicationEvents *ApplicationEvents;
			TAction *NewAction;
			TAction *OpenAction;
			TAction *SaveAction;
			TAction *PrintAction;
			TEditUndo *UndoAction;
			TEditCut *CutAction;
			TEditCopy *CopyAction;
			TEditPaste *PasteAction;
			TWindowCascade *CascadeAction;
			TWindowTileHorizontal *TileAction;
			TWindowArrange *ArrangeAction;
			THelpContents *ContentsAction;
			TAction *AboutAction;

		TCoolBar *CoolBar;
		TToolBar *ToolBar1;
			TToolButton *NewToolButton;
			TToolButton *OpenToolButton;
			TToolButton *SaveToolButton;
			TToolButton *ToolButton1;
			TToolButton *CutToolButton;
			TToolButton *CopyToolButton;
			TToolButton *PasteToolButton;
			TToolButton *ToolButton2;
			TToolButton *PrintToolButton;
			TToolButton *ToolButton3;
			TToolButton *AboutToolButton;
			TToolButton *HelpToolButton;

		void __fastcall ApplicationEventsHint(TObject *Sender);
		void __fastcall ApplicationEventsIdle(TObject *Sender, bool &Done);

		void __fastcall NewActionExecute(TObject *Sender);
		void __fastcall OpenActionExecute(TObject *Sender);
		void __fastcall SaveActionExecute(TObject *Sender);
		void __fastcall PrintActionExecute(TObject *Sender);
		void __fastcall AboutActionExecute(TObject *Sender);

		void __fastcall FileMenuClick(TObject *Sender);
		void __fastcall FileCloseClick(TObject *Sender);
		void __fastcall FileSaveAsClick(TObject *Sender);
		void __fastcall FileExitClick(TObject *Sender);

		void __fastcall ViewToolbarClick(TObject *Sender);
		void __fastcall ViewStatusBarClick(TObject *Sender);

		void __fastcall WindowMenuClick(TObject *Sender);

		void __fastcall ToolbarPopupMenuPopup(TObject *Sender);

	private:
		int doc_counter;
		TChild* child;

	public:
		__fastcall TMain(TComponent* Owner):
		TForm(Owner),
		doc_counter(2){};
		UINT __cdecl show_error(char* format, ...);
};
//---------------------------------------------------------------------------

extern PACKAGE TMain *Main;
//---------------------------------------------------------------------------

#endif
